


Jochen Sarrazin, DG6VJ                        Mnster, 04.05.97
<sarrazin@muenster.de>                        Version 0.32
DG6VJ @ DB0EA.#NRW.DEU.EU                     vjboxd-Version: 0.7c


0. nderungen seit Version 0.31:
================================

  PUTMAIL:    - Neue Antwort: 117
              - Als Verteiler kann '?' angegeben werden.
  SHOWLOGINS: - Neu
  MSG:        - Mehr Informationen ber die interne Arbeitsweise
  RELEASE:    - Neu, aber noch nicht implementiert
  PUT         - Neu




1. Allgemeines:
===============

  In dieser Spezifikation stehen die schon implementierten Befehle
  drin. Bug-Berichte etc bitte an eine der obenstehenden Adressen.

  Die einzelnen Befehle bestehen aus je einem einzelnen Wort, meist
  gefolgt von einem oder mehreren Parmetern. Jede unmittelbare Antwort
  auf einen Befehl beginnt mit einer 3-stelligen Zahl.

  001: Der gesendete Befehl ist unbekannt.
  002: Der Befehl ist bekannt, kann aber nur nach erfolgter Login-Prozedur
       ausgefhrt werden.
  099: Es folgen Infos, die per MSG-Befehl von anderen Prozessen an den
       eigenen gesendet werden.

  


2. Befehle des Frontends an den vjbox-Daemon:
=============================================

LOGIN <call>
  Ein User loggt ein. Notwendig fr die Userverwaltung des Kernels.
  (Siehe 'Anmeldeprozedur'.)


PUTMAIL <rubrik> <verteiler> <lifetime> [<laenge>]
  Der User will eine Mail schreiben / hat geschrieben.
  Wenn keine Lnge mitgegeben wurde, wird die Eingabe mit einem einzelnen
  Punkt abgebrochen. Ansonsten wird die angegebene Anzahl Bytes gelesen,
  in das File geschrieben. Ist die Lifetime unbekannt, wird -1 angegeben.
   Nur fr lokal empfangene Mails (keine thirdparty-Mail), da der Daemon
  die ntigen Header erzeugt.
   Ist der Verteiler nicht bekannt, kann ein '?' angegeben werden. Bei
  Bulletins wird als Verteiler das eigene Mailbox-Rufzeichen benutzt, bei
  Usermails wird in der MYBBS-Datenbank gesucht. Ist dort kein Eintrag
  vorhanden, wird die Meldung "117 Unknown destination-box." ausgegeben.
   In der ersten Zeile nach der Antwort des Daemonen wird das Subject
  gesendet, danach kommt die eigentliche Mail.
 Antwort:
  111 Syntax Error.
  112 Waiting for the subject.
  113 OK, end with a single dot.
  114 OK, waiting for <anz> bytes.
  115 Sorry, access denied.
  117 Unknown destination-box.
 Vollzugsmeldung:
  116 OK, file saved.


VERSION
  Versions-Informationen der Mailbox. Wenn von Interesse einfach 1:1
  nach der eigenen Versionsinfo aussenden.
 Antwort:
  121 Versions-Informationen vjboxd:
  Text Text
  .  (Abgeschlossen mit einem einzelnen Punkt)


NEWMAIL <time> <rubrik/en> [long]
   Gibt eine Liste der Mails in den angegebenen Rubriken (mit Komma zu
  trennen) aus, die nach dem angegebenen Zeitpunkt empfangen wurden.
  Es werden die BIDs der Mails ausgegeben (ohne <>, mit \n getrennt),
  danach kommt ein einzelner Punkt.
  Die Liste beginnt mit dem neusten Bulletin und endet mit dem
  ltesten.
   Wird das Schlsselwort "long" als letzter Parameter angegeben, werden
  neben der BID noch weitere Informationen wie Rubrik, Absender etc
  mitgeschickt. Erkennbar sind solche Informationen darin, da sie durch
  ein SPACE links eingerckt wurden. In der ersten eingerckten Zeile
  steht, durch jeweils 1 SPACE getrennt: Rubrik, MBX, Absender, Absendedatum,
  Lnge der Mail in Bytes, Lifetime ,die Nummer des Datensatzes, wo diese
  Mail im Index-File abgespeichert ist und evtl. ein String mit Flags, die
  je aus einem Buchstaben bestehen (z.B. H = HOLD). In der zweiten eingerckten
  Zeile wird die Subject-Zeile der Mail ausgegeben.
   Durch das Schlsselwort "all" werden Bulletins- und Usermails angezeigt.
  Dies ist eigentlich nur fr Store & Forward-Clients notwendig, normale
  Clients sollten hiervon keinen Gebrauch machen.
 Antwort:
  131 Syntax error.
  132 New mail follow


GETMAIL <bid> [B]
  Die Mail mit der angegebenen BID soll ausgelesen werden.
  Wenn ein 'B' als zweiten Parameter angegeben wird, wird die Antwort 146
  erzeugt und in der ersten Zeile die Lnge der Mail gesendet. Die Mail wird
  in diesem Fall nicht mit einem '.' abgeschlossen.
 Antwort:
  141 Syntax error.
  142 Unknown BID.
  143 BID <BID> follows:
  144 Sorry, access denied.
  145 Datafile not available.
  146 BID <BID> follows (no point at the end):


HEADER <bid>
  Zeigt den Header einer Mail an.
 Antwort:
  151 Syntax error.
  152 Unknown BID.
  153 BID <BID> follows:
  154 Sorry, access denied.
  155 Datafile not available.


PUT <absender> <bid> <typ> <rubrik> <verteiler> <lifetime> [<laenge>]
  Von einem S&F-Client kommt eine Nachricht an.
   Ist die BID unbekannt, kann ein '?' gesendet werden. Der Daemon
  erzeugt dann eine eigene BID.
   Der Typ der Mail kann sein: P (Usermail), B (Bulletin), A (Ack),
  ? (die Box sucht es sich selbst 'raus).
   Wenn keine Lnge mitgegeben wurde, wird die Eingabe mit einem einzelnen
  Punkt abgebrochen. Ansonsten wird die angegebene Anzahl Bytes gelesen,
  in das File geschrieben. Ist die Lifetime unbekannt, wird -1 angegeben.
   Ist der Verteiler nicht bekannt, kann ein '?' angegeben werden. Bei
  Bulletins wird als Verteiler das eigene Mailbox-Rufzeichen benutzt, bei
  Usermails wird in der MYBBS-Datenbank gesucht. Ist dort kein Eintrag
  vorhanden, wird die Meldung "117 Unknown destination-box." ausgegeben.
   In der ersten Zeile nach der Antwort des Daemonen wird das Subject
  gesendet, danach kommt die eigentliche Mail.
 Antwort:
  161 Syntax Error.
  162 Waiting for the subject.
  163 OK, end with a single dot.
  164 OK, waiting for <anz> bytes.
  165 Sorry, access denied.
  167 Unknown destination-box.
  168 Wrong filetype.
  169 BID is known.
 Vollzugsmeldung:
  166 OK, file saved.



MYBBS <call>
  Setzt das eigene MYBBS
 Antwort:
  511 Syntax error.
  512 OK, MYBBS set to <call> (<unixtime>).


READLOCK <0|1|2>
  Setzt das Readlock-Byte fr das eigene Userfile.
 Antwort:
  521 Syntax error.
  522 Wrong value.              (nur 0, 1 und 2 sind erlaubt)
  523 OK, Readlock set to <0|1|2>.


MSG <pid> <text>
  Schreibt den angegebenen Text an den User, dessen Kindprozess auf
  PID <pid> luft. (Siehe *.pid - Files im ./userdata - Verzeichnis)
  *NUR* einzelige Messages abschicken!
  Der Client guckt alle 2 Sekunden, ob eine neue Message eingetroffen ist.
  Wenn welche vorhanden sind, werden sie ausgesendet, wenn kein anderer
  Befehl abgearbeitet wird.
 Antwort:
  531 Syntax error.
  532 PID <pid> is not available.
  533 Failure while sending.
  534 OK, message sent.


BOARDLIST
  Gibt eine Liste aller der Mailbox bekannten Rubriken mitsamt Lifetime-
  Angabe aus. Beendet wird sie mit ".\n". (Sowas wie ein DIR-Befehl)
  Grundlage sind die Index-Files.
 Format:
  <rubrik_lcase> <u|b> <anzahl> [<lt> <maxlt>]
  <u|b>: u = Usermail, b = Bulletin
 Antwort:
  541 Error     (Irgend ein Fehler ist aufgetreten)
  542 Boardlist follow:


GETINFO <call>
  Gibt Informationen ber das bergebene Rufzeichen aus.
 Antwort:
  551 Syntax error.
  552 User unknown.
  553 Userinfo for <call>:


NAME <name>
  Setzt den eigenen Namen. Wird z.B. fr den PUTMAIL-Befehl bentigt, wo
  in Klammern hinter der From: - Zeile der eigene Name angegeben wird.
 Antwort:
  561 Syntax error.
  562 Name set to <name>.


SHOWLOGIN
  Zeigt eine Liste der eingeloggten User an.
 Antwort:
  571 Users:
  572 Error.


RELEASE <bid>
  Lscht das Hold-Flag der Mail mit der angegebenen BID, so da sie fr
  alle lesbar wird / geforwardet wird.
 Antwort:
  581 Sorry, access denied.
  582 Done.


CHANGEBOX <rufzeichen>
  Wechselt die aktuelle User-Mailbox.
 Antwort:
  211 Syntax error.
  212 Sorry, access denied.
  213 Unknown.
  214 Actual mailbox: <Rufzeichen>. <count> mails available.


LISTBOX <time> [long]
  Listet die BIDs aller Mails in der aktuellen User-Mailbox nach dem in <time>
  angegebenen Zeitpunkt. (Alle Mails: time=0)
  Abgeschlossen wird diese Liste mit ".\n"
  Wird nach der Zeit noch das Schlsselwort "long" mitgesendet, wird die
  Ausgabe jeder BID um zwei Zeilen mit zustzlichen Informationen erweitert.
  Sie haben das selbe Format wie bei NEWMAIL und werden ebenfalls mit einem
  SPACE eingeleitet.
 Antwort:
  221 Syntax error.
  222 New mail follow


GETBOX <bid>
  Gibt die Mail mit der angegebenen BID an den Client aus.
 Antwort:
  231 Syntax error.
  232 Unknown BID <bid>.
  233 BID <bid> follows:
  234 Sorry, access denied.
  235 Datafile not available.



READ <Rubrik> <Nr>
  Liest aus der angegebenen Rubrik die gewnschte Mail und gibt sie aus.
  Das Ausgabeformat ist identisch mit dem der Ausgabe des GETMAIL-Befehls.
 Antwort:
  301 Syntax error.
  302 Unknown board.
  303 Unknown mailnumber.
  304 Datafile not available.
  305 OK, Mail follows:
  306 Sorry, access denied.


LIST <Rubrik> <Von> <Bis>
  Listet die bergebenen Mails in der angegebenen Rubrik auf.
  Das Ausgabenformat ist das gleiche wie beim NEWMAIL LONG-Befehl.
 Antwort:
  311 Syntax error.
  312 Unknown board.
  313 Sorry, access denied.
  314 OK, list <rubrik> from <von> to <bis>:




3. Anmeldeprozedur:
===================

> = User->Daemon; < = Daemon->User

> LOGIN <rufzeichen>

< 101 <boxcall_mit_hierarchie> <daemon-version> [md2-zufallszahlen]

> PASS [md2-antwort]

< 102 Welcome dg4iad, blabla
oder
< 103 Sorry, access denied.

Es folgen jetzt diverse Informationen der Mailbox ber den einloggenden
User, die mit ".\n" abgeschlossen werden. (MYBBS, Readlock-Infos etc)
Und zwar:
  mybbs <rufzeichen> (<unix-time-of-set>)
  readlock <0|1|2>
  readlock-friends <rl-friend-rufzeichen>
  lastlogin <unix-time>
  lastquit <unix-time>
Es mssen nicht alle vorkommen. Wird eine Information nicht angegeben,
ist sie nicht bekannt.  

Die Zeile 103 kann auch schon direkt nach LOGIN kommen, dann ist der User
im badcalls - File enthalten, und darf garnicht einloggen.
Sind nach der Daemon-Version keine md2-Zufallszahlen in eckigen Klammern
vorhanden, ist kein Passwortschutz aktiviert (nur im Anfangs/Beta-Stadium).


